: m01.mod: a simple ODE y'' = -y

DEFINE nstates 9

NEURON {
    SUFFIX mna
}

UNITS {
    (mV) = (millivolt)
}

ASSIGNED {
    v      (mV)          : postsynaptic voltage
}

STATE { z0 z1 z2 z3 z4 z5 z6 z7 z8 }

INITIAL {
    z0 = 1.0
    z1 = 0.0
    z2 = 0.0
    z3 = 0.0
    z4 = 0.0
    z5 = 0.0
    z6 = 0.0
    z7 = 0.0
    z8 = 0.0
}
  
BREAKPOINT{
    SOLVE zstates METHOD cnexp
}

LOCAL a11, a12, a13, b11, b12, b13, a3, b3, a2, b2, a4, b4, a5, b5 

DERIVATIVE zstates {
    a11 = 3.802/(0.1027*exp(-v/17.0) + 0.20*exp(-v/150))    
    a12 = 3.802/(0.1027*exp(-v/15.0) + 0.23*exp(-v/150))
    a13 = 3.802/(0.1027*exp(-v/12.0) + 0.25*exp(-v/150))
	
    b11 = 0.1917*exp(-v/20.3)
    b12 = 0.20*exp(-(v-5)/20.3)
    b13 = 0.22*exp(-(v-10)/20.3)
        
    a3 = (3.7933e-7)*exp(-v/7.7)    
    b3 = 0.0084 + 0.00002*v        
	
    a2 = 9.178*exp(v/29.68)
    b2 = (a13*a2*a3)/(b13*b3)
	
    a4 = a2/100
    b4 = a3

    a5 = a2/(9.5e4)    
    b5 = a3/50       

    z0' = -(a11 + b3)*z0 + b11*z1 + a3*z4  
    z1' = -(b11 + b3 + a12)*z1 + a11*z0 + b12*z2 + a3*z5 
    z2' = -(b12 + b3 + a13)*z2 + a12*z1 + b13*z3 + a3*z6 
    z3' = -(b13 + a2)*z3 + a13*z2 + b2*z6 
    z4' = -(a11 + a3)*z4 + b11*z5 + b3*z0
    z5' = -(b11 + a3 + a12)*z5 + a11*z4 + b12*z6 + b3*z1 
    z6' = -(b12 + a3 + b2 + a4)*z6 + a12*z5 + b3*z2 + a2*z3 + b4*z7
    z7' = -(b4 + a5)*z7 + a4*z6 + b5*z8
    z8' = -b5*z8 + a5*z7
}