# n15.py  Markov model of Na channel

import numpy as np
import neuron
from neuron import h
import matplotlib.pyplot as plt

nstates = 9

tstop = 10.0
v_init = -100.0

c = h.Section()
c.insert('mna')
h.dt = 0.05

vc = h.VClamp(0.5, sec=c)
vc.dur[0] = 2.0
vc.dur[1] = 5.0
vc.dur[2] = 3.0
vc.amp[0] = v_init
vc.amp[1] = 0.0
vc.amp[2] = v_init

tv = h.Vector()
zv = [h.Vector() for i in range(nstates)]

tv.record(h._ref_t)
for i in range(nstates):
    s = 'zv[%1d].record(c(0.5)._ref_z%1d_mna)'% (i, i)
    exec(s)

h.finitialize(v_init)
h.fcurrent()
neuron.run(tstop)

ax = plt.subplot()
for i in range(nstates):
    ax.plot(tv.as_numpy(), zv[i].as_numpy())

plt.xlabel('Time')
plt.ylabel('Probability')
plt.savefig('../figs/n15.pdf')  
plt.show()
