# n17.py
 
import neuron
from neuron import h
import numpy as np
import matplotlib.pyplot as plt

#h.load_file ("nrngui.hoc")
h.load_file ("../models/cellModel.hoc")

tstop = 100
v_init = -65
ncells = 20

cells = []
for i in range(ncells): 
    cells.append(h.BallStickCell( ))

nclist = []
for i in range(len(cells)):
    target = cells[(i+1) % ncells]   # next cell
    nc = cells[i].connect2target(target.synlist[0])
    nclist.append(nc)
    nc.delay = 1
    nc.weight[0] = 0.01

#external stimulus to syn of cells[0]
stim = h.NetStim()
stim.number = 1
stim.start = 0
ncstim = h.NetCon(stim, cells[0].synlist[0])
ncstim.delay=0
ncstim.weight[0] = 0.01

tvec  = h.Vector( )
idvec = h.Vector( )
for i in range( len(cells) ):
    nc = cells[i].connect2target(None)
    nc.record (tvec, idvec, i)

# Simulation control
h.finitialize(v_init)
neuron.run(tstop)

print ("\ntime\t cell\n")
for i in range(int(tvec.size())):
    print (i, tvec.x[i], idvec.x[i])
print("tvec.size=",tvec.size())

ax1 = plt.subplot()
ax1.plot(tvec.as_numpy(), idvec.as_numpy(),'|')
plt.xlabel('Time (ms)')
plt.ylabel('Cell number')
plt.savefig('../figs/n17.pdf')  
plt.show()

"""
spikes = [np.empty(0) for i in range(ncells)]
for i in range(int(tvec.size())):
    j = int(idvec.x[i])
    spikes[j] = np.append(spikes[j],tvec.x[i])
ax1 = plt.subplot()
ax1.eventplot(spikes, colors=[[1.0, 0, 0]])
plt.show()
"""
